                    ;      

          processor 12f629  
          include <p12F629.inc>

     __CONFIG 3F84H
   errorlevel-302
      cblock  20H
      speed_reg
      door_reg
	Reg_1	  	
	Reg_2
	Reg_3
	FLAG        
	                             ; 0- 
	                             ; 1- 
	                             ; 2- 
	                             ; 3-  - 
                                   ; 4-  
                                   ; 5-  
	endc
	
KEY     equ  5
DOOR equ  0
LED     equ  4
SIGNAL  equ  1 

                                          ; 
;--------------------------------------------------------------------------
MAIN	
      clrf	       GPIO
      movlw  .7                            ;  
      movwf   CMCON               ;     
	bsf	       STATUS, RP0	 ;   1
	movlw	b'00101101'	        ; 0,2,3,5   .
	movwf	TRISIO
	movlw   b'00101000'          ; .  TMR0 . 
	movwf	 OPTION_REG     ; . . 
	movlw  b'00100101'
	movwf  WPU
	;movlw  .12
	call	      0x3ff 	                   ;   
	movwf	OSCCAL               ;  .
    	bcf	      STATUS, RP0	        ;   0
	clrf       INTCON
      clrf       FLAG      
   ;----------------------------------------------------------------------
CYCLE_M    
                 ;      EEPROM
     ;--------------------------------------------------------------------
       clrw             			       ;   h'00'
       CALL    READ_MEM 
       movwf  speed_reg                  ;    
     ;--------------------------------------------------------------------
                   ;    - ""   EEPROM
;--------------------------------------------------------------------------------------
      movlw  .1
      CALL  READ_MEM          ;   EEPROM
      movwf  door_reg                  ;    
;--------------------------------------------------------------------------------------

CYCLE
     CALL   DOOR_ON  
     CALL   KEY_ON 
     btfss     FLAG, KEY             ;  ?
     goto      m0
     btfss     FLAG, DOOR
     goto      m1
     CALL   IZMER
     bsf        STATUS, RP0      	        ;  1
     movwf  EEDATA
     movlw  .1
     movwf  EEADR     
     CALL  WRITE_MEM 
     goto     CYCLE_M 
m0                  
     btfss    FLAG, DOOR
     goto     m2
     CALL PR_D
     btfss     FLAG, 3
     goto      CYCLE  
     ;---------------------------------------
     bsf      GPIO, SIGNAL
     ;call     DELAY_250
     call     DELAY_250          ;  ""
     bcf      GPIO, SIGNAL 	
     call     DELAY_250
     ;call     DELAY_250
     goto   CYCLE
m1
     CALL  IZMER 
     bsf        STATUS, RP0      	        ;  1
     movwf  EEDATA
     clrf       EEADR     
     CALL  WRITE_MEM  
     goto     CYCLE_M
m2
     CALL   PR_S 
     btfss     FLAG, 2
     goto      CYCLE 
     ;-----------------------------------------
            bsf      GPIO, SIGNAL
            ;call     DELAY_250
            call     DELAY_250
            bcf      GPIO, SIGNAL	
	      call     DELAY_250
            call     DELAY_250
            call     DELAY_250
            call     DELAY_250
            call     DELAY_250
            call     DELAY_250
            call     DELAY_250
            call     DELAY_250
	      goto   CYCLE 

                            ;  

;----------------------------------------------------------------------------------	
DELAY_005                            ; 5
            movlw       .125
            movwf       Reg_1
            movlw       .7
            movwf       Reg_2
            decfsz      Reg_1,F
            goto        $-1
            decfsz      Reg_2,F
            goto        $-3
            return
;-------------------------------------------------------------------------------
DELAY_250           ; 250
            movlw       .169
            movwf       Reg_1
            movlw       .69
            movwf       Reg_2
            movlw       .2
            movwf       Reg_3
            decfsz      Reg_1,F
            goto        $-1
            decfsz      Reg_2,F
            goto        $-3
            decfsz      Reg_3,F
            goto        $-5
            nop
            nop
            return
;-------------------------------------------------------------------------------
                        ;   EEPROM
;-------------------------------------------------------------------
WRITE_MEM
        bsf        EECON1, WREN     ;    EEPROM
        bcf        INTCON, GIE
                  ;   
        movlw  55h
        movwf  EECON2
        movlw  h'AA'
        movwf  EECON2
        bsf        EECON1, WR           ;    
wr_wait                     ;   
        bcf        STATUS, RP0     	 ;   0
        bsf        INTCON, GIE
        btfss      PIR1, EEIF    		 ;    
        goto      wr_wait         		 ;   
        bcf       PIR1, EEIF            	 ;  
        
            bsf      GPIO, SIGNAL
            call     DELAY_250
            call     DELAY_250
            call     DELAY_250
            call     DELAY_250
            bcf      GPIO, SIGNAL 
        return
;---------------------------------------------------------------------------------------------------
READ_MEM
       bsf        STATUS, RP0          ;   1
       movwf   EEADR 
       bsf        EECON1, RD            ; 
       movfw     EEDATA                ;     W
       bcf        STATUS, RP0          ;   0 
       return
;------------------------------------------------------------------------------
DOOR_ON
     bcf        FLAG, DOOR
     btfsc     GPIO, DOOR       ;  
     return                       
     call       DELAY_005
     btfsc     GPIO, DOOR
     return
     bsf        FLAG, DOOR              ;   
     return  
 ;--------------------------------------------------------------------
KEY_ON
     bcf        FLAG, KEY
     btfsc     GPIO, KEY           ;  
     return                       
     call       DELAY_005
     btfsc     GPIO, KEY
     return
     bsf        FLAG, KEY                ;   
     return  
;-----------------------------------------------------------------------
PR_S
     bcf        FLAG, 2
     call       IZMER 
     subwf   speed_reg, W
     btfss     STATUS, C
     bsf        FLAG, 2            ;  
     return 
;----------------------------------------------------------------------
PR_D
     bcf        FLAG, 3
     call       IZMER
     subwf   door_reg, W
     btfss     STATUS, C
     bsf        FLAG, 3          ;   - 
     return 
;---------------------------------------------------------------------
IZMER
     clrf       TMR0
     call       DELAY_250 
     movfw  TMR0
     return
	END
   
